diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-mac-queue-scheduler.h ns-3.40/src/wifi/model/wifi-mac-queue-scheduler.h
--- ns-3.39/src/wifi/model/wifi-mac-queue-scheduler.h	2023-07-05 14:23:48.121428500 -0700
+++ ns-3.40/src/wifi/model/wifi-mac-queue-scheduler.h	2023-09-27 13:30:37.914839700 -0700
@@ -45,6 +45,7 @@
     POWER_SAVE_MODE,
     USING_OTHER_EMLSR_LINK,
     WAITING_EMLSR_TRANSITION_DELAY,
+    TID_NOT_MAPPED,
     REASONS_COUNT
 };
 
@@ -68,6 +69,8 @@
         return (os << "USING_OTHER_EMLSR_LINK");
     case WifiQueueBlockedReason::WAITING_EMLSR_TRANSITION_DELAY:
         return (os << "WAITING_EMLSR_TRANSITION_DELAY");
+    case WifiQueueBlockedReason::TID_NOT_MAPPED:
+        return (os << "TID_NOT_MAPPED");
     case WifiQueueBlockedReason::REASONS_COUNT:
         return (os << "REASONS_COUNT");
     default:
@@ -101,26 +104,29 @@
     /**
      * Get the next queue to serve, which is guaranteed to contain at least an MPDU
      * whose lifetime has not expired. Queues containing MPDUs that cannot be sent
-     * over the given link are ignored.
+     * over the given link (if any) are ignored.
      *
      * \param ac the Access Category that we want to serve
-     * \param linkId the ID of the link on which we got channel access
+     * \param linkId the ID of the link on which MPDUs contained in the returned queue must be
+     *               allowed to be sent
      * \return the ID of the selected container queue (if any)
      */
-    virtual std::optional<WifiContainerQueueId> GetNext(AcIndex ac, uint8_t linkId) = 0;
+    virtual std::optional<WifiContainerQueueId> GetNext(AcIndex ac,
+                                                        std::optional<uint8_t> linkId) = 0;
     /**
      * Get the next queue to serve after the given one. The returned queue is
      * guaranteed to contain at least an MPDU whose lifetime has not expired.
-     * Queues containing MPDUs that cannot be sent over the given link are ignored.
+     * Queues containing MPDUs that cannot be sent over the given link (if any) are ignored.
      *
      * \param ac the Access Category that we want to serve
-     * \param linkId the ID of the link on which we got channel access
+     * \param linkId the ID of the link on which MPDUs contained in the returned queue must be
+     *               allowed to be sent
      * \param prevQueueId the ID of the container queue served previously
      * \return the ID of the selected container queue (if any)
      */
     virtual std::optional<WifiContainerQueueId> GetNext(
         AcIndex ac,
-        uint8_t linkId,
+        std::optional<uint8_t> linkId,
         const WifiContainerQueueId& prevQueueId) = 0;
 
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-mac-queue-scheduler-impl.h ns-3.40/src/wifi/model/wifi-mac-queue-scheduler-impl.h
--- ns-3.39/src/wifi/model/wifi-mac-queue-scheduler-impl.h	2023-07-05 14:23:48.121428500 -0700
+++ ns-3.40/src/wifi/model/wifi-mac-queue-scheduler-impl.h	2023-09-27 13:30:37.914839700 -0700
@@ -24,6 +24,7 @@
 #include "wifi-mac-queue.h"
 #include "wifi-mac.h"
 
+#include <algorithm>
 #include <functional>
 #include <list>
 #include <map>
@@ -66,11 +67,14 @@
 
     /** \copydoc ns3::WifiMacQueueScheduler::SetWifiMac */
     void SetWifiMac(Ptr<WifiMac> mac) final;
-    /** \copydoc ns3::WifiMacQueueScheduler::GetNext(AcIndex,uint8_t) */
-    std::optional<WifiContainerQueueId> GetNext(AcIndex ac, uint8_t linkId) final;
-    /** \copydoc ns3::WifiMacQueueScheduler::GetNext(AcIndex,uint8_t,const WifiContainerQueueId&) */
+    /** \copydoc ns3::WifiMacQueueScheduler::GetNext(AcIndex,std::optional<uint8_t>) */
+    std::optional<WifiContainerQueueId> GetNext(AcIndex ac, std::optional<uint8_t> linkId) final;
+    /**
+     *  \copydoc ns3::WifiMacQueueScheduler::GetNext(AcIndex,std::optional<uint8_t>,
+     *           const WifiContainerQueueId&)
+     */
     std::optional<WifiContainerQueueId> GetNext(AcIndex ac,
-                                                uint8_t linkId,
+                                                std::optional<uint8_t> linkId,
                                                 const WifiContainerQueueId& prevQueueId) final;
     /** \copydoc ns3::WifiMacQueueScheduler::GetLinkIds */
     std::list<uint8_t> GetLinkIds(AcIndex ac, Ptr<const WifiMpdu> mpdu) final;
@@ -202,12 +206,13 @@
      * Queues containing MPDUs that cannot be sent over the given link are ignored.
      *
      * \param ac the Access Category that we want to serve
-     * \param linkId the ID of the link on which we got channel access
+     * \param linkId the ID of the link on which MPDUs contained in the returned queue must be
+     *               allowed to be sent
      * \param sortedQueuesIt iterator pointing to the queue we start the search from
      * \return the ID of the selected container queue (if any)
      */
     std::optional<WifiContainerQueueId> DoGetNext(AcIndex ac,
-                                                  uint8_t linkId,
+                                                  std::optional<uint8_t> linkId,
                                                   typename SortedQueues::iterator sortedQueuesIt);
 
     /**
@@ -352,16 +357,15 @@
 
         // this assert checks that the RA field also contain an MLD address, unless
         // it contains the broadcast address
-        NS_ASSERT_MSG(rxAddr.IsGroup() || GetMac()->GetMldAddress(rxAddr),
+        NS_ASSERT_MSG(rxAddr.IsGroup() || GetMac()->GetMldAddress(rxAddr) == rxAddr,
                       "Address 1 (" << rxAddr << ") is not an MLD address");
 
         // this assert checks that association (ML setup) has been established
         // between sender and receiver (unless the receiver is the broadcast address)
         NS_ASSERT_MSG(GetMac()->CanForwardPacketsTo(rxAddr), "Cannot forward frame to " << rxAddr);
-
         // we have to include all the links in case of broadcast frame (we are an AP)
         // and the links that have been setup with the receiver in case of unicast frame
-        for (uint8_t linkId = 0; linkId < GetMac()->GetNLinks(); linkId++)
+        for (const auto linkId : GetMac()->GetLinkIds())
         {
             if (rxAddr.IsGroup() ||
                 GetMac()->GetWifiRemoteStationManager(linkId)->GetAffiliatedStaAddress(rxAddr))
@@ -567,19 +571,19 @@
 
 template <class Priority, class Compare>
 std::optional<WifiContainerQueueId>
-WifiMacQueueSchedulerImpl<Priority, Compare>::GetNext(AcIndex ac, uint8_t linkId)
+WifiMacQueueSchedulerImpl<Priority, Compare>::GetNext(AcIndex ac, std::optional<uint8_t> linkId)
 {
-    NS_LOG_FUNCTION(this << +ac << +linkId);
+    NS_LOG_FUNCTION(this << +ac << linkId.has_value());
     return DoGetNext(ac, linkId, m_perAcInfo[ac].sortedQueues.begin());
 }
 
 template <class Priority, class Compare>
 std::optional<WifiContainerQueueId>
 WifiMacQueueSchedulerImpl<Priority, Compare>::GetNext(AcIndex ac,
-                                                      uint8_t linkId,
+                                                      std::optional<uint8_t> linkId,
                                                       const WifiContainerQueueId& prevQueueId)
 {
-    NS_LOG_FUNCTION(this << +ac << +linkId);
+    NS_LOG_FUNCTION(this << +ac << linkId.has_value());
 
     auto queueInfoIt = m_perAcInfo[ac].queueInfoMap.find(prevQueueId);
     NS_ABORT_IF(queueInfoIt == m_perAcInfo[ac].queueInfoMap.end() ||
@@ -595,19 +599,20 @@
 std::optional<WifiContainerQueueId>
 WifiMacQueueSchedulerImpl<Priority, Compare>::DoGetNext(
     AcIndex ac,
-    uint8_t linkId,
+    std::optional<uint8_t> linkId,
     typename SortedQueues::iterator sortedQueuesIt)
 {
-    NS_LOG_FUNCTION(this << +ac << +linkId);
+    NS_LOG_FUNCTION(this << +ac << linkId.has_value());
     NS_ASSERT(static_cast<uint8_t>(ac) < AC_UNDEF);
 
     while (sortedQueuesIt != m_perAcInfo[ac].sortedQueues.end())
     {
         const auto& queueInfoPair = sortedQueuesIt->second.get();
         const auto& linkIds = queueInfoPair.second.linkIds;
+        typename std::decay_t<decltype(linkIds)>::const_iterator linkIt;
 
-        if (const auto linkIt = linkIds.find(linkId);
-            linkIt != linkIds.cend() && linkIt->second.none())
+        if (!linkId.has_value() ||
+            ((linkIt = linkIds.find(*linkId)) != linkIds.cend() && linkIt->second.none()))
         {
             // Packets in this queue can be sent over the link we got channel access on.
             // Now remove packets with expired lifetime from this queue.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-mgt-header.h ns-3.40/src/wifi/model/wifi-mgt-header.h
--- ns-3.39/src/wifi/model/wifi-mgt-header.h	2023-07-05 14:23:48.121428500 -0700
+++ ns-3.40/src/wifi/model/wifi-mgt-header.h	2023-09-27 13:30:37.918840000 -0700
@@ -21,11 +21,11 @@
 #define WIFI_MGT_HEADER_H
 
 #include "non-inheritance.h"
+#include "supported-rates.h"
 
 #include "ns3/eht-capabilities.h"
 #include "ns3/header.h"
 #include "ns3/multi-link-element.h"
-#include "ns3/supported-rates.h"
 
 #include <algorithm>
 #include <iterator>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-mode.cc ns-3.40/src/wifi/model/wifi-mode.cc
--- ns-3.39/src/wifi/model/wifi-mode.cc	2023-07-05 14:23:48.121428500 -0700
+++ ns-3.40/src/wifi/model/wifi-mode.cc	2023-09-27 13:30:37.918840000 -0700
@@ -349,9 +349,8 @@
 WifiMode
 WifiModeFactory::Search(std::string name) const
 {
-    WifiModeItemList::const_iterator i;
     uint32_t j = 0;
-    for (i = m_itemList.begin(); i != m_itemList.end(); i++)
+    for (auto i = m_itemList.begin(); i != m_itemList.end(); i++)
     {
         if (i->uniqueUid == name)
         {
@@ -364,7 +363,7 @@
     // is a fatal problem, but we try to be helpful by displaying the
     // list of WifiModes that are supported.
     NS_LOG_UNCOND("Could not find match for WifiMode named \"" << name << "\". Valid options are:");
-    for (i = m_itemList.begin(); i != m_itemList.end(); i++)
+    for (auto i = m_itemList.begin(); i != m_itemList.end(); i++)
     {
         NS_LOG_UNCOND("  " << i->uniqueUid);
     }
@@ -384,7 +383,7 @@
 WifiModeFactory::AllocateUid(std::string uniqueUid)
 {
     uint32_t j = 0;
-    for (WifiModeItemList::const_iterator i = m_itemList.begin(); i != m_itemList.end(); i++)
+    for (auto i = m_itemList.begin(); i != m_itemList.end(); i++)
     {
         if (i->uniqueUid == uniqueUid)
         {
@@ -392,7 +391,7 @@
         }
         j++;
     }
-    uint32_t uid = static_cast<uint32_t>(m_itemList.size());
+    auto uid = static_cast<uint32_t>(m_itemList.size());
     m_itemList.emplace_back();
     return uid;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-net-device.cc ns-3.40/src/wifi/model/wifi-net-device.cc
--- ns-3.39/src/wifi/model/wifi-net-device.cc	2023-07-05 14:23:48.121428500 -0700
+++ ns-3.40/src/wifi/model/wifi-net-device.cc	2023-09-27 13:30:37.918840000 -0700
@@ -394,7 +394,7 @@
     if (m_mac->GetTypeOfStation() == STA &&
         (staMac = StaticCast<StaWifiMac>(m_mac))->IsAssociated() && m_mac->GetNLinks() > 1 &&
         (linkIds = staMac->GetSetupLinkIds()).size() == 1 &&
-        !GetRemoteStationManager(*linkIds.begin())
+        !m_mac->GetWifiRemoteStationManager(*linkIds.begin())
              ->GetMldAddress(m_mac->GetBssid(*linkIds.begin())))
     {
         return m_mac->GetFrameExchangeManager(*linkIds.begin())->GetAddress();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-phy.cc ns-3.40/src/wifi/model/wifi-phy.cc
--- ns-3.39/src/wifi/model/wifi-phy.cc	2023-07-05 14:23:48.125428400 -0700
+++ ns-3.40/src/wifi/model/wifi-phy.cc	2023-09-27 13:30:37.918840000 -0700
@@ -1249,7 +1249,7 @@
 WifiPhy::SetNumberOfAntennas(uint8_t antennas)
 {
     NS_LOG_FUNCTION(this << +antennas);
-    NS_ASSERT_MSG(antennas > 0 && antennas <= 4, "unsupported number of antennas");
+    NS_ASSERT_MSG(antennas > 0 && antennas <= 8, "unsupported number of antennas");
     m_numberOfAntennas = antennas;
     if (m_interference)
     {
@@ -1725,7 +1725,30 @@
     NS_ASSERT(!m_state->IsStateTx() && !m_state->IsStateSwitching());
     NS_ASSERT(m_endTxEvent.IsExpired());
 
-    if (txVector.GetNssMax() > GetMaxSupportedTxSpatialStreams())
+    if (!txVector.IsValid())
+    {
+        NS_FATAL_ERROR("TX-VECTOR is invalid!");
+    }
+
+    uint8_t nss = 0;
+    if (txVector.IsMu())
+    {
+        // We do not support mixed OFDMA and MU-MIMO
+        if (txVector.IsDlMuMimo())
+        {
+            nss = txVector.GetNssTotal();
+        }
+        else
+        {
+            nss = txVector.GetNssMax();
+        }
+    }
+    else
+    {
+        nss = txVector.GetNss();
+    }
+
+    if (nss > GetMaxSupportedTxSpatialStreams())
     {
         NS_FATAL_ERROR("Unsupported number of spatial streams!");
     }
@@ -1747,9 +1770,7 @@
     {
         noEndPreambleDetectionEvent &= it.second->NoEndPreambleDetectionEvents();
     }
-    if (!noEndPreambleDetectionEvent ||
-        (m_currentEvent &&
-         (m_currentEvent->GetEndTime() > (Simulator::Now() + m_state->GetDelayUntilIdle()))))
+    if (!noEndPreambleDetectionEvent || m_currentEvent)
     {
         AbortCurrentReception(RECEPTION_ABORTED_BY_TX);
     }
@@ -1817,6 +1838,13 @@
 }
 
 void
+WifiPhy::SetPreviouslyRxPpduUid(uint64_t uid)
+{
+    NS_ASSERT(m_standard >= WIFI_STANDARD_80211be);
+    m_previouslyRxPpduUid = uid;
+}
+
+void
 WifiPhy::Reset()
 {
     NS_LOG_FUNCTION(this);
@@ -1846,7 +1874,7 @@
         // TODO find a fallback PHY for receiving the PPDU (e.g. 11a for 11ax due to preamble
         // structure)
         NS_LOG_DEBUG("Unsupported modulation received (" << modulation << "), consider as noise");
-        m_interference->Add(ppdu, ppdu->GetTxVector(), rxDuration, rxPowersW);
+        m_interference->Add(ppdu, rxDuration, rxPowersW);
         SwitchMaybeToCcaBusy(nullptr);
     }
 }
@@ -2146,7 +2174,7 @@
     }
     else
     {
-        if (txVector.GetNssMax() > 1)
+        if (txVector.GetNssMax() > 1 || txVector.GetNssTotal() > 1)
         {
             txPowerDbm = std::min(m_txPowerMaxMimo, GetPowerDbm(txVector.GetTxPowerLevel()));
         }
@@ -2157,7 +2185,7 @@
     }
 
     // Apply power density constraint on EIRP
-    uint16_t channelWidth = ppdu->GetTransmissionChannelWidth();
+    uint16_t channelWidth = ppdu->GetTxChannelWidth();
     double txPowerDbmPerMhz =
         (txPowerDbm + GetTxGain()) - RatioToDb(channelWidth); // account for antenna gain since EIRP
     NS_LOG_INFO("txPowerDbm=" << txPowerDbm << " with txPowerDbmPerMhz=" << txPowerDbmPerMhz
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-phy-common.h ns-3.40/src/wifi/model/wifi-phy-common.h
--- ns-3.39/src/wifi/model/wifi-phy-common.h	2023-07-05 14:23:48.125428400 -0700
+++ ns-3.40/src/wifi/model/wifi-phy-common.h	2023-09-27 13:30:37.918840000 -0700
@@ -60,6 +60,9 @@
     WifiSpectrumBandFrequencies frequencies; //!< the start and stop frequencies of the band
 };
 
+/// vector of spectrum bands
+using WifiSpectrumBands = std::vector<WifiSpectrumBandInfo>;
+
 /**
  * \ingroup wifi
  * Compare two bands.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-phy.h ns-3.40/src/wifi/model/wifi-phy.h
--- ns-3.39/src/wifi/model/wifi-phy.h	2023-07-05 14:23:48.125428400 -0700
+++ ns-3.40/src/wifi/model/wifi-phy.h	2023-09-27 13:30:37.918840000 -0700
@@ -1123,6 +1123,18 @@
     uint64_t GetPreviouslyRxPpduUid() const;
 
     /**
+     * Set the UID of the previously received PPDU.
+     *
+     * \param uid the value for the UID of the previously received PPDU
+     *
+     * \note This method shall only be used in exceptional circumstances, such as when a PHY
+     * transmits a response to a Trigger Frame that was received by another PHY. This is the
+     * case, e.g., when an aux PHY of an EMLSR client receives an ICF but it is the main PHY
+     * that switches channel and transmits the response to the ICF.
+     */
+    void SetPreviouslyRxPpduUid(uint64_t uid);
+
+    /**
      * \param currentChannelWidth channel width of the current transmission (MHz)
      * \return the width of the guard band (MHz)
      *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-ppdu.cc ns-3.40/src/wifi/model/wifi-ppdu.cc
--- ns-3.39/src/wifi/model/wifi-ppdu.cc	2023-07-05 14:23:48.125428400 -0700
+++ ns-3.40/src/wifi/model/wifi-ppdu.cc	2023-09-27 13:30:37.918840000 -0700
@@ -19,10 +19,10 @@
 
 #include "wifi-ppdu.h"
 
+#include "wifi-phy-operating-channel.h"
 #include "wifi-psdu.h"
 
 #include "ns3/log.h"
-#include "ns3/wifi-phy-operating-channel.h"
 
 namespace ns3
 {
@@ -42,7 +42,9 @@
       m_txVector(txVector),
       m_operatingChannel(channel),
       m_truncatedTx(false),
-      m_txPowerLevel(txVector.GetTxPowerLevel())
+      m_txPowerLevel(txVector.GetTxPowerLevel()),
+      m_txAntennas(txVector.GetNTx()),
+      m_txChannelWidth(txVector.GetChannelWidth())
 {
     NS_LOG_FUNCTION(this << *psdu << txVector << channel << uid);
     m_psdus.insert(std::make_pair(SU_STA_ID, psdu));
@@ -63,7 +65,8 @@
       m_operatingChannel(channel),
       m_truncatedTx(false),
       m_txPowerLevel(txVector.GetTxPowerLevel()),
-      m_txAntennas(txVector.GetNTx())
+      m_txAntennas(txVector.GetNTx()),
+      m_txChannelWidth(txVector.GetChannelWidth())
 {
     NS_LOG_FUNCTION(this << psdus << txVector << channel << uid);
     m_psdus = psdus;
@@ -86,6 +89,7 @@
         m_txVector = DoGetTxVector();
         m_txVector->SetTxPowerLevel(m_txPowerLevel);
         m_txVector->SetNTx(m_txAntennas);
+        m_txVector->SetChannelWidth(m_txChannelWidth);
     }
     return m_txVector.value();
 }
@@ -139,9 +143,9 @@
 }
 
 uint16_t
-WifiPpdu::GetTransmissionChannelWidth() const
+WifiPpdu::GetTxChannelWidth() const
 {
-    return GetTxVector().GetChannelWidth();
+    return m_txChannelWidth;
 }
 
 uint16_t
@@ -154,9 +158,8 @@
 WifiPpdu::DoesOverlapChannel(uint16_t minFreq, uint16_t maxFreq) const
 {
     NS_LOG_FUNCTION(this << m_txCenterFreq << minFreq << maxFreq);
-    uint16_t txChannelWidth = GetTxVector().GetChannelWidth();
-    uint16_t minTxFreq = m_txCenterFreq - txChannelWidth / 2;
-    uint16_t maxTxFreq = m_txCenterFreq + txChannelWidth / 2;
+    uint16_t minTxFreq = m_txCenterFreq - m_txChannelWidth / 2;
+    uint16_t maxTxFreq = m_txCenterFreq + m_txChannelWidth / 2;
     /**
      * The PPDU does not overlap the channel in two cases.
      *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-ppdu.h ns-3.40/src/wifi/model/wifi-ppdu.h
--- ns-3.39/src/wifi/model/wifi-ppdu.h	2023-07-05 14:23:48.125428400 -0700
+++ ns-3.40/src/wifi/model/wifi-ppdu.h	2023-09-27 13:30:37.918840000 -0700
@@ -134,7 +134,7 @@
      *
      * \return the effective channel width (in MHz) used for the tranmsission
      */
-    virtual uint16_t GetTransmissionChannelWidth() const;
+    virtual uint16_t GetTxChannelWidth() const;
 
     /**
      * \return the center frequency (MHz) used for the transmission of this PPDU
@@ -222,7 +222,13 @@
     uint8_t m_txPowerLevel; //!< the transmission power level (used only for TX and initializing the
                             //!< returned WifiTxVector)
     uint8_t m_txAntennas;   //!< the number of antennas used to transmit this PPDU
-};                          // class WifiPpdu
+
+    uint16_t m_txChannelWidth; /**< The channel width (MHz) used for the transmission of this
+                                         PPDU. This has to be stored since channel width can not
+                                         always be obtained from the PHY headers, especially for
+                                         non-HT PPDU, since we do not sense the spectrum to
+                                         determine the occupied channel width for simplicity. */
+};                             // class WifiPpdu
 
 /**
  * \brief Stream insertion operator.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-remote-station-manager.cc ns-3.40/src/wifi/model/wifi-remote-station-manager.cc
--- ns-3.39/src/wifi/model/wifi-remote-station-manager.cc	2023-07-05 14:23:48.125428400 -0700
+++ ns-3.40/src/wifi/model/wifi-remote-station-manager.cc	2023-09-27 13:30:37.918840000 -0700
@@ -390,11 +390,9 @@
     NS_LOG_FUNCTION(this << address);
     NS_ASSERT(!address.IsGroup());
     auto state = LookupState(address);
-    state->m_operationalMcsSet.clear();
-    for (const auto& mcs : m_wifiPhy->GetMcsList())
-    {
-        state->m_operationalMcsSet.push_back(mcs);
-    }
+
+    const auto& mcsList = m_wifiPhy->GetMcsList();
+    state->m_operationalMcsSet = WifiModeList(mcsList.begin(), mcsList.end());
 }
 
 void
@@ -565,21 +563,16 @@
     LookupState(address)->m_isInPsMode = isInPsMode;
 }
 
-void
-WifiRemoteStationManager::SetMldAddress(const Mac48Address& address, const Mac48Address& mldAddress)
-{
-    NS_LOG_FUNCTION(this << address << mldAddress);
-
-    auto state = LookupState(address);
-    state->m_mldAddress = mldAddress;
-    // insert another entry in m_states indexed by the MLD address and pointing to the same state
-    const_cast<WifiRemoteStationManager*>(this)->m_states.insert({mldAddress, state});
-}
-
 std::optional<Mac48Address>
 WifiRemoteStationManager::GetMldAddress(const Mac48Address& address) const
 {
-    return LookupState(address)->m_mldAddress;
+    if (auto stateIt = m_states.find(address);
+        stateIt != m_states.end() && stateIt->second->m_mleCommonInfo)
+    {
+        return stateIt->second->m_mleCommonInfo->m_mldMacAddress;
+    }
+
+    return std::nullopt;
 }
 
 std::optional<Mac48Address>
@@ -587,13 +580,13 @@
 {
     auto stateIt = m_states.find(mldAddress);
 
-    if (stateIt == m_states.end() || !stateIt->second->m_mldAddress)
+    if (stateIt == m_states.end() || !stateIt->second->m_mleCommonInfo)
     {
         // MLD address not found
         return std::nullopt;
     }
 
-    NS_ASSERT(*stateIt->second->m_mldAddress == mldAddress);
+    NS_ASSERT(stateIt->second->m_mleCommonInfo->m_mldMacAddress == mldAddress);
     return stateIt->second->m_address;
 }
 
@@ -652,7 +645,7 @@
     {
         txVector = DoGetDataTxVector(Lookup(address), allowedWidth);
         txVector.SetLdpc(txVector.GetMode().GetModulationClass() < WIFI_MOD_CLASS_HT
-                             ? 0
+                             ? false
                              : UseLdpcForDestination(address));
     }
     Ptr<HeConfiguration> heConfiguration = m_wifiPhy->GetDevice()->GetHeConfiguration();
@@ -1169,7 +1162,7 @@
     {
         // search for the BSS Basic Rate set, if the used mode is in the basic set then there is no
         // need for CTS To Self
-        for (WifiModeListIterator i = m_bssBasicRateSet.begin(); i != m_bssBasicRateSet.end(); i++)
+        for (auto i = m_bssBasicRateSet.begin(); i != m_bssBasicRateSet.end(); i++)
         {
             if (mode == *i)
             {
@@ -1181,8 +1174,7 @@
         {
             // search for the BSS Basic MCS set, if the used mode is in the basic set then there is
             // no need for CTS To Self
-            for (WifiModeListIterator i = m_bssBasicMcsSet.begin(); i != m_bssBasicMcsSet.end();
-                 i++)
+            for (auto i = m_bssBasicMcsSet.begin(); i != m_bssBasicMcsSet.end(); i++)
             {
                 if (mode == *i)
                 {
@@ -1422,7 +1414,7 @@
     state->m_vhtCapabilities = nullptr;
     state->m_heCapabilities = nullptr;
     state->m_ehtCapabilities = nullptr;
-    state->m_emlCapabilities = nullptr;
+    state->m_mleCommonInfo = nullptr;
     state->m_emlsrEnabled = false;
     state->m_channelWidth = m_wifiPhy->GetChannelWidth();
     state->m_guardInterval = GetGuardInterval();
@@ -1557,7 +1549,7 @@
             state->m_channelWidth = 20;
         }
     }
-    if (heCapabilities.GetHeSuPpdu1xHeLtf800nsGi() == 1)
+    if (heCapabilities.GetHeSuPpdu1xHeLtf800nsGi())
     {
         state->m_guardInterval = 800;
     }
@@ -1600,12 +1592,16 @@
 }
 
 void
-WifiRemoteStationManager::AddStationEmlCapabilities(
+WifiRemoteStationManager::AddStationMleCommonInfo(
     Mac48Address from,
-    const std::shared_ptr<CommonInfoBasicMle::EmlCapabilities>& emlCapabilities)
+    const std::shared_ptr<CommonInfoBasicMle>& mleCommonInfo)
 {
     NS_LOG_FUNCTION(this << from);
-    LookupState(from)->m_emlCapabilities = emlCapabilities;
+    auto state = LookupState(from);
+    state->m_mleCommonInfo = mleCommonInfo;
+    // insert another entry in m_states indexed by the MLD address and pointing to the same state
+    const_cast<WifiRemoteStationManager*>(this)->m_states.insert(
+        {mleCommonInfo->m_mldMacAddress, state});
 }
 
 Ptr<const HtCapabilities>
@@ -1632,10 +1628,26 @@
     return LookupState(from)->m_ehtCapabilities;
 }
 
-std::shared_ptr<CommonInfoBasicMle::EmlCapabilities>
+std::optional<std::reference_wrapper<CommonInfoBasicMle::EmlCapabilities>>
 WifiRemoteStationManager::GetStationEmlCapabilities(const Mac48Address& from)
 {
-    return LookupState(from)->m_emlCapabilities;
+    if (auto state = LookupState(from);
+        state->m_mleCommonInfo && state->m_mleCommonInfo->m_emlCapabilities)
+    {
+        return state->m_mleCommonInfo->m_emlCapabilities.value();
+    }
+    return std::nullopt;
+}
+
+std::optional<std::reference_wrapper<CommonInfoBasicMle::MldCapabilities>>
+WifiRemoteStationManager::GetStationMldCapabilities(const Mac48Address& from)
+{
+    if (auto state = LookupState(from);
+        state->m_mleCommonInfo && state->m_mleCommonInfo->m_mldCapabilities)
+    {
+        return state->m_mleCommonInfo->m_mldCapabilities.value();
+    }
+    return std::nullopt;
 }
 
 bool
@@ -1748,7 +1760,7 @@
 WifiRemoteStationManager::GetNNonErpBasicModes() const
 {
     uint32_t size = 0;
-    for (WifiModeListIterator i = m_bssBasicRateSet.begin(); i != m_bssBasicRateSet.end(); i++)
+    for (auto i = m_bssBasicRateSet.begin(); i != m_bssBasicRateSet.end(); i++)
     {
         if (i->GetModulationClass() == WIFI_MOD_CLASS_ERP_OFDM)
         {
@@ -1765,7 +1777,7 @@
     NS_ASSERT(i < GetNNonErpBasicModes());
     uint32_t index = 0;
     bool found = false;
-    for (WifiModeListIterator j = m_bssBasicRateSet.begin(); j != m_bssBasicRateSet.end();)
+    for (auto j = m_bssBasicRateSet.begin(); j != m_bssBasicRateSet.end();)
     {
         if (i == index)
         {
@@ -1889,7 +1901,7 @@
     // moved in case it breaks standard rules.
     uint32_t index = 0;
     bool found = false;
-    for (WifiModeListIterator j = station->m_state->m_operationalRateSet.begin();
+    for (auto j = station->m_state->m_operationalRateSet.begin();
          j != station->m_state->m_operationalRateSet.end();)
     {
         if (i == index)
@@ -2014,8 +2026,9 @@
 bool
 WifiRemoteStationManager::GetEmlsrSupported(const WifiRemoteStation* station) const
 {
-    auto emlCapabilities = station->m_state->m_emlCapabilities;
-    return emlCapabilities && emlCapabilities->emlsrSupport == 1;
+    auto mleCommonInfo = station->m_state->m_mleCommonInfo;
+    return mleCommonInfo && mleCommonInfo->m_emlCapabilities &&
+           mleCommonInfo->m_emlCapabilities->emlsrSupport == 1;
 }
 
 bool
@@ -2034,7 +2047,7 @@
 WifiRemoteStationManager::GetNNonErpSupported(const WifiRemoteStation* station) const
 {
     uint32_t size = 0;
-    for (WifiModeListIterator i = station->m_state->m_operationalRateSet.begin();
+    for (auto i = station->m_state->m_operationalRateSet.begin();
          i != station->m_state->m_operationalRateSet.end();
          i++)
     {
@@ -2128,8 +2141,9 @@
 bool
 WifiRemoteStationManager::GetEmlsrSupported(const Mac48Address& address) const
 {
-    auto emlCapabilities = LookupState(address)->m_emlCapabilities;
-    return emlCapabilities && emlCapabilities->emlsrSupport == 1;
+    auto mleCommonInfo = LookupState(address)->m_mleCommonInfo;
+    return mleCommonInfo && mleCommonInfo->m_emlCapabilities &&
+           mleCommonInfo->m_emlCapabilities->emlsrSupport == 1;
 }
 
 bool
